FA.JustBlog/FA.JustBlog/Areas/Admin/Controllers/PostController.cs
using FA.JustBlog.Core;
using FA.JustBlog.Repository.Implement;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace FA.JustBlog.Areas.Admin.Controllers
{
	
	public class PostController : Controller
	{
		private readonly UnitOfWork unitOfWork = new UnitOfWork(new JustBlogContext());

		// GET: Admin/Post
		[AllowAnonymous]
		public ViewResult Index()
		{
			return View();
		}
		[AllowAnonymous]
		public PartialViewResult IndexGrid()
		{
			return PartialView("_IndexGrid", unitOfWork.PostRepository.GetAllPosts());
		}

		//public ActionResult Index()
		//{
		//	return View(unitOfWork.PostRepository.GetAllPosts());
		//}
		[Authorize(Roles = "Admin,Contributor")]
		public ActionResult AddPost()
		{
			ViewBag.categories = new SelectList(unitOfWork.CategoryRepository.GetAllCategories(), "CategoryId", "Name");
			return View();
		}
		[HttpPost]
		[ValidateAntiForgeryToken]
		[ValidateInput(false)]
		[Authorize(Roles = "Admin,Contributor")]
		public ActionResult AddPost(Post post)
		{
			if (ModelState.IsValid)
			{
				ViewBag.categories = new SelectList(unitOfWork.CategoryRepository.GetAllCategories(), "CategoryId", "Name");

				if (post != null)
				{
					unitOfWork.PostRepository.AddPost(post);
					return RedirectToAction("Index", "Home");
				}
			}

			return View();
		}
		[AllowAnonymous]
		public ActionResult Details(int id)
		{
			var post = unitOfWork.PostRepository.Find(id);
			if (post == null)
				return HttpNotFound();
			return View(post);
		}

		[Authorize(Roles = "Admin,Contributor")]
		public ActionResult Edit(int id)
		{
			ViewBag.categories = new SelectList(unitOfWork.CategoryRepository.GetAllCategories(), "CategoryId", "Name");
			var post = unitOfWork.PostRepository.Find(id);
			return View(post);
		}
		[HttpPost]
		[ValidateAntiForgeryToken]
		[ValidateInput(false)]
		[Authorize(Roles = "Admin,Contributor")]
		public ActionResult Edit(Post post)
		{		
			unitOfWork.PostRepository.UpdatePost(post);
			return RedirectToAction("Index");

		}

		[Authorize(Roles = "Admin")]
		public ActionResult Delete(int id)
		{
			Post postExisting = unitOfWork.PostRepository.Find(id);
			return View(postExisting);
		}
		[HttpPost]
		[Authorize(Roles = "Admin")]
		public ActionResult Delete(int id, Post post)
		{
			Post postExisting = unitOfWork.PostRepository.Find(id);
			unitOfWork.PostRepository.DeletePost(postExisting);
			return RedirectToAction("Index");
		}

		public ActionResult LatestPosts()
		{
			var lastPost = unitOfWork.PostRepository.GetLatestPost();
			return View(lastPost);
		}

		public ActionResult MostViewedPosts()
		{
			var mostView = unitOfWork.PostRepository.GetMostViewedPost();
			return View(mostView);
		}

		[Authorize(Roles = "Admin")]
		public ActionResult Published()
		{
			var mostView = unitOfWork.PostRepository.GetPublished();
			return View(mostView);
		}

		[Authorize(Roles = "Admin")]
		public ActionResult UnPublished()
		{
			var mostView = unitOfWork.PostRepository.GetUnPublished();
			return View(mostView);
			//return Json(new { rows = mostView }, JsonRequestBehavior.AllowGet);
		}

	}
}

FA.JustBlog/FA.JustBlog/Controllers/PostController.cs
using FA.JustBlog.Core;
using FA.JustBlog.Repository.Implement;
using PagedList;
using System.Web.Mvc;

namespace FA.JustBlog.Controllers
{
	public class PostController : Controller
	{
		private readonly UnitOfWork unitOfWork = new UnitOfWork(new JustBlogContext());
		// GET: Post

		public ActionResult Index(int? page)
		{
			if (page == null) page = 1;
			int pageSize = 3;
			int pageNumber = (page ?? 1);
			return View(unitOfWork.PostRepository.GetAllPosts().ToPagedList(pageNumber, pageSize));
		}

		public ActionResult GetAll()
		{
			return View(unitOfWork.PostRepository.GetAllPosts());
		}

		public ActionResult Details(int year, int month, string title)
		{
			var post = unitOfWork.PostRepository.FindPost(year, month, title);
			if (post == null)
				return HttpNotFound();
			return View(post);
		}

		[ChildActionOnly]
		public ActionResult MostViewedPosts()
		{
			var mostView = unitOfWork.PostRepository.GetMostViewedPost();

			return PartialView("_ListPosts", mostView);
		}

		[ChildActionOnly]
		public ActionResult LatestPosts()
		{
			var lastPost = unitOfWork.PostRepository.GetLatestPost();
			return PartialView("_ListPosts", lastPost);
		}

		public ActionResult GetAllByCategory(int id)
		{
			var listposts = unitOfWork.PostRepository.GetPostByCategory(id);
			return View(listposts);
		}

		public ActionResult GetAllByTag(int tagId)
		{
			var listposts = unitOfWork.PostRepository.GetPostByTag(tagId);
			return View(listposts);
		}
	}
}

FA.JustBlog/FA.JustBlog/Views/Post/Details.cshtml
@model FA.JustBlog.Core.Post

@{
	ViewBag.Title = "Details";
	Layout = "~/Views/Shared/_LayoutPage1.cshtml";
}

<h2>Details Post</h2>

<div>
	<h3>@Html.DisplayFor(m => m.Title)</h3>
	<small class="post-meta">
		Posted @Html.DisplayFor(m=>m.PostedOn) with rate to by @Model.ViewCount view
	</small>
	<h5><b>@Html.DisplayFor(m=>m.ShortDescription)</b></h5>
	<p>@Html.DisplayFor(m=>m.Description)</p>
</div>
<p>
	@*@Html.ActionLink("Edit", "Edit", new { id = Model.PostId }) |*@
	@Html.ActionLink("Back to List", "Index", new {@class="text-successs"})


</p>

FA.JustBlog/FA.JustBlog/Views/Post/GetAll.cshtml
@model List<FA.JustBlog.Core.Post>
@using FA.JustBlog.Extensions
@{
	ViewBag.Title = "GetAll";
	Layout = "~/Views/Shared/Post/_ListPosts.cshtml";
}

<h1>All posts!</h1>

<div class="container>
		@foreach (var item in Model)
		{
			<div class="post-preview">

				@*<h2 class="post-title text-primary"><a href="/post/details/@item.PostId"> @item.Title</a> </h2>*@
				@Html.PostLink(item);
				<br />
				<small class="post-meta">
					Posted @item.PostedOn.ToString() with rate to by @item.ViewCount view
				</small>
				<p><b>@item.ShortDescription</b></p>

			</div>
			<hr />
		}
</div>

FA.JustBlog/FA.JustBlog/Views/Post/GetAllByCategory.cshtml
@model IEnumerable<FA.JustBlog.Core.Post>
@using FA.JustBlog.Extensions
@{
	ViewBag.Title = "GetAllByCategory";
	Layout = "~/Views/Shared/_LayoutPage1.cshtml";
}

<h2>GetAllByCategory</h2>

<div class="container>
	@foreach (var item in Model)
	{
		<div class="post-preview">

			@*<h2 class="post-title text-primary"><a href="/post/details/@item.PostId"> @item.Title</a> </h2>*@
			@Html.ActionLink(item.Title, "Details", "Post", new
	   {
		   year = item.PostedOn.Year,
		   month = item.PostedOn.Month.ToString("00"),
		   title = item.UrlSlug,

	   }, new { @class = "h4 text-primary" })
			<br />
			<small class="post-meta">
				Posted @Html.PostedOn(item.PostedOn) with rate to by @item.ViewCount view
			</small>
			<p><b>@item.ShortDescription</b></p>

		</div>
		<hr />
	}
</div>

FA.JustBlog/FA.JustBlog/Views/Post/Index.cshtml
@model PagedList.IPagedList<FA.JustBlog.Core.Post>

@using FA.JustBlog.Extensions
@using PagedList.Mvc

@{
	ViewBag.Title = "Index";
	Layout = "~/Views/Shared/_LayoutPage1.cshtml";
}

<h1>All posts!</h1>

<div class="container>
	@foreach (var item in Model)
	{
		<div class="post-preview">

			@Html.PostLink(item)
			<br />
			<small class="post-meta">
				Posted @Html.PostedOn(item.PostedOn) with rate to by @item.ViewCount view
			</small>
			<p><b>@item.ShortDescription</b></p>

		</div>
		<hr />

	}

</div>

<div id="container" style="margin-left: 20px">
	<p></p>
	<p></p>
	<div class="pagination" style="margin-left: 400px">
		Page @(Model.PageCount < Model.PageNumber ? 0 : Model.PageNumber)
		of @Model.PageCount  @Html.PagedListPager(Model, page => Url.Action("Index", new { page  }))
	</div>
</div>

FA.JustBlog/FA.JustBlog/Views/Post/LatestPosts.cshtml
@using FA.JustBlog.Extensions
@model IEnumerable<FA.JustBlog.Core.Post>

@{
	ViewBag.Title = "MostViewedPosts";
	Layout = "~/Views/Shared/Post/_ListPosts.cshtml";
}
<h2>Top 5 Latest Posts</h2>
<hr />
<div class="container>
	@foreach (var item in Model)
	{
		<div class="post-preview">

			@*<h2 class="post-title text-primary"><a href="/post/details/@item.PostId"> @item.Title</a> </h2>*@
			@Html.ActionLink(item.Title, "Details", "Post", new
	   {
		   year = item.PostedOn.Year,
		   month = item.PostedOn.Month.ToString("00"),
		   title = item.UrlSlug,

	   }, new { @class = "h4 text-primary" })
			<br />
			<small class="post-meta">
				Posted @Html.PostedOn(item.PostedOn) with rate to by @item.ViewCount view
			</small>
			<p><b>@item.ShortDescription</b></p>

		</div>
		<hr />
	}
</div>

FA.JustBlog/FA.JustBlog/Views/Post/MostViewedPosts.cshtml
@using FA.JustBlog.Extensions
@model IEnumerable<FA.JustBlog.Core.Post>

@{
	ViewBag.Title = "MostViewedPosts";
	Layout = "~/Views/Shared/Post/_ListPosts.cshtml";
}
<h2>Top 5 posts have highest ViewCount</h2>
<hr />
<div class="container>
	@foreach (var item in Model)
	{
		<div class="post-preview">

			@*<h2 class="post-title text-primary"><a href="/post/details/@item.PostId"> @item.Title</a> </h2>*@
			@Html.ActionLink(item.Title, "Details", "Post", new
	   {
		   year = item.PostedOn.Year,
		   month = item.PostedOn.Month.ToString("00"),
		   title = item.UrlSlug,

	   }, new { @class = "h4 text-primary" })
			<br />
			<small class="post-meta">
				Posted @Html.PostedOn(item.PostedOn) with rate to by @item.ViewCount view
			</small>
			<p><b>@item.ShortDescription</b></p>

		</div>
		<hr />
	}
</div>

FA.JustBlog/FA.JustBlog/Views/Post/_ListPosts.cshtml
@model List<FA.JustBlog.Core.Post>
@using FA.JustBlog.Extensions


	@foreach (var item in Model)
	{
		<div class="post-preview">

			@Html.PostLink(item)
			<br />
			<small class="post-meta">
				Posted @Html.PostedOn(item.PostedOn) with rate to by @item.ViewCount view
			</small>
			@*<p><b>@item.ShortDescription</b></p>*@

		</div>
		<hr />

	}